'use strict';
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
// Avoid "Possible EventEmitter memory leak detected" warnings
// because it breaks pnpm's CLI output
process.setMaxListeners(0);
const argv = process.argv.slice(2);
(async () => {
    switch (argv[0]) {
        case '-v':
        case '--version': {
            const { version } = (await Promise.resolve().then(() => __importStar(require('@pnpm/cli-meta')))).default;
            console.log(version);
            break;
        }
        case 'install-completion': {
            const { install: installCompletion } = await Promise.resolve().then(() => __importStar(require('@pnpm/tabtab')));
            await installCompletion({ name: 'pnpm', completer: 'pnpm' });
            return;
        }
        case 'uninstall-completion': {
            const { uninstall: uninstallCompletion } = await Promise.resolve().then(() => __importStar(require('@pnpm/tabtab')));
            await uninstallCompletion({ name: 'pnpm' });
            return;
        }
        // commands that are passed through to npm:
        case 'access':
        case 'adduser':
        case 'bugs':
        case 'c':
        case 'config':
        case 'deprecate':
        case 'dist-tag':
        case 'docs':
        case 'edit':
        case 'get':
        case 'info':
        case 'init':
        case 'login':
        case 'logout':
        case 'owner':
        case 'ping':
        case 'prefix':
        case 'profile':
        case 'repo':
        case 's':
        case 'se':
        case 'search':
        case 'set':
        case 'star':
        case 'stars':
        case 'team':
        case 'token':
        case 'unpublish':
        case 'unstar':
        case 'v':
        case 'version':
        case 'view':
        case 'whoami':
        case 'xmas':
            await passThruToNpm();
            break;
        default:
            await runPnpm();
            break;
    }
})();
async function runPnpm() {
    const errorHandler = (await Promise.resolve().then(() => __importStar(require('../err')))).default;
    try {
        const main = (await Promise.resolve().then(() => __importStar(require('../main')))).default;
        await main(argv);
    }
    catch (err) {
        errorHandler(err);
    }
}
async function passThruToNpm() {
    const runNpm = (await Promise.resolve().then(() => __importStar(require('../runNpm')))).default;
    const { status } = await runNpm(argv);
    process.exit(status);
}
