"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const filterImporter_1 = __importDefault(require("./filterImporter"));
const R = require("ramda");
function filterLockfile(lockfile, opts) {
    var _a;
    let pairs = Object.entries((_a = lockfile.packages) !== null && _a !== void 0 ? _a : {})
        .filter(([depPath, pkg]) => !opts.skipped.has(depPath));
    if (!opts.include.dependencies) {
        pairs = pairs.filter(([depPath, pkg]) => pkg.dev !== false || pkg.optional);
    }
    if (!opts.include.devDependencies) {
        pairs = pairs.filter(([depPath, pkg]) => pkg.dev !== true);
    }
    if (!opts.include.optionalDependencies) {
        pairs = pairs.filter(([depPath, pkg]) => !pkg.optional);
    }
    return {
        importers: Object.keys(lockfile.importers).reduce((acc, importerId) => {
            acc[importerId] = filterImporter_1.default(lockfile.importers[importerId], opts.include);
            return acc;
        }, {}),
        lockfileVersion: lockfile.lockfileVersion,
        packages: R.fromPairs(pairs),
    };
}
exports.default = filterLockfile;
//# sourceMappingURL=filterLockfile.js.map