"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const logger_1 = __importDefault(require("@pnpm/logger"));
const list_1 = require("./list");
exports.default = async (pkgs, params, opts) => {
    var _a, _b;
    const depth = (_a = opts.depth) !== null && _a !== void 0 ? _a : 0;
    if (opts.lockfileDir) {
        return list_1.render(pkgs.map((pkg) => pkg.dir), params, {
            ...opts,
            alwaysPrintRootPackage: depth === -1,
            lockfileDir: opts.lockfileDir,
        });
    }
    const outputs = [];
    for (const { dir } of pkgs) {
        try {
            const output = await list_1.render([dir], params, {
                ...opts,
                alwaysPrintRootPackage: depth === -1,
                lockfileDir: (_b = opts.lockfileDir) !== null && _b !== void 0 ? _b : dir,
            });
            if (!output)
                continue;
            outputs.push(output);
        }
        catch (err) {
            logger_1.default.info(err);
            err['prefix'] = dir; // eslint-disable-line @typescript-eslint/dot-notation
            throw err;
        }
    }
    if (outputs.length === 0)
        return '';
    const joiner = typeof depth === 'number' && depth > -1 ? '\n\n' : '\n';
    return outputs.join(joiner);
};
//# sourceMappingURL=recursive.js.map