"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.splitNodeId = exports.createNodeId = exports.nodeIdContainsSequence = void 0;
function nodeIdContainsSequence(nodeId, pkgId1, pkgId2) {
    const pkgIds = splitNodeId(nodeId);
    pkgIds.pop();
    const pkg1Index = pkgIds.indexOf(pkgId1);
    if (pkg1Index === -1)
        return false;
    const pkg2Index = pkgIds.indexOf(pkgId2);
    return pkg2Index > -1 && pkg1Index < pkg2Index;
}
exports.nodeIdContainsSequence = nodeIdContainsSequence;
function createNodeId(parentNodeId, pkgId) {
    // using ">" as a separator because it will never be used inside a package ID
    return `${parentNodeId}${pkgId}>`;
}
exports.createNodeId = createNodeId;
function splitNodeId(nodeId) {
    return nodeId.substr(1, nodeId.length - 2).split('>');
}
exports.splitNodeId = splitNodeId;
//# sourceMappingURL=nodeIdUtils.js.map